/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "DDLeafNode.h"
#include <sstream>

#ifdef __USE_TEMPLATES__
    namespace double_description {
        template<>
        LeafNode<PreliminaryCondition> LeafNode<PreliminaryCondition>::EMPTY_NODE;

        template<>
        LeafNode<PreliminaryCondition>::LeafNode() :
	        TreeNode( BitList(), &PreliminaryCondition::TRIVIAL_FAIL ),
	        mRefsCount( 0 ),
	        mRefs( NULL ) {}     
    }   
#else
    using namespace double_description;

    LeafNode LeafNode::EMPTY_NODE;

    LeafNode::LeafNode () :
	    TreeNode( BitList(), &PreliminaryCondition::TRIVIAL_FAIL ),
	    mRefsCount( 0 ),
	    mRefs( NULL ) {}
#endif
